import de.bezier.data.sql.*;

MySQL msql;

int[] sportsItems = new int[366];
int[] sportsDay = new int[366];
int[] sportsMonth = new int[366];

int width = 1280;
int height = 960;

int maxIndex;
int maxS;

int minIndex;
int minS;

int avg;

PFont fnt;

int sec;

void setup(){
  size(width,height);
  smooth();
  background(28,0,0);
  
  //  // connecting to the SPL database
    msql = new MySQL( this, "tango.mat.ucsb.edu", "spl0", "mat259", "V1sual1zat1on" ); //host, database, user, password
    if ( msql.connect() )
    { 
      String TheQuery="SELECT day(cout) as Days, month(cout) as Months, cout as Dates, SUM(case When subj like \"%sport%\" Then 1 Else 0 End) as SportsItems FROM inraw WHERE year(cout)=\"2008\" GROUP BY date(cout);";
          println(TheQuery);
          msql.query( TheQuery);
          msql.next();
          int count = 0;
          while( msql.next() ){
              println("Day: " + msql.getString(1) + "Month" + " " + msql.getString(2) + " " + msql.getString(3) + " " + "Cout: "+ msql.getString(4) + " " + count );
              sportsItems[count] = msql.getInt(4);
              sportsDay[count] = msql.getInt(1);
              sportsMonth[count] = msql.getInt(2);
              //println(msql.getInt(4));
              count++;
          }     
     }
    else
    {
      println(" connection failed !");
    }
    //setup for display text
    
    fnt = createFont("Helvetica",64,true);
    
    //findMin
    minIndex = 0;
    minS = sportsItems[0];
    for(int i = 0; i<=361; i++){   
      if(sportsItems[i] < minS && sportsItems[i] != 0){
        minS = sportsItems[i];
        minIndex = i;
      }
    }
    println(minS+ " "+ minIndex);
    
    //findmax
    maxIndex = 0;
    maxS = sportsItems[0];
    for(int i=0;i<=361;i++){
      if(sportsItems[i] > maxS){
        maxS = sportsItems[i];
        maxIndex = i;
      }
    }
    println(maxS+ " "+ maxIndex);
   //findAvg
   avg = findAvg();
   //println(avg);//avg is 132
    
}

void draw(){
  background(28,0,0);
  smooth();
  //insert text title
  textFont(fnt,64);
  textAlign(CENTER);
  fill(#7EB5D6);
  text("2008 Sports Checkouts", width/2,height*.2);
  
  //horizontal line
  line(width*.02, height*.9, width*.98, height*.9);
  
  //vertical lines
  for(int i=0;i<=361;i++){
    //alpha/opacity
    int opacity = (sportsItems[i]*255+1)/maxS;
    if(opacity<=75)
      opacity = 75;
    
    if(sportsMonth[i] == 1)
      //stroke(128,128,128); //black
      stroke(#2A75A9,opacity);
    if(sportsMonth[i] == 2)
      //stroke(228,15,15); //red
      stroke(#7FACCB,opacity);
    if(sportsMonth[i] == 3)
      //stroke(228,250,25);//yellow
       stroke(#2A75A9,opacity);
    if(sportsMonth[i] == 4)
      //stroke(25,250,40); //light green
      stroke(#7FACCB,opacity);
    if(sportsMonth[i] == 5)
      //stroke(11,102,41);//dark green
       stroke(#2A75A9,opacity);
    if(sportsMonth[i] == 6)
      //stroke(14,232,101);//turqoise
      stroke(#7FACCB,opacity);
    if(sportsMonth[i] == 7)
      //stroke(14,58,232);//dark blue
       stroke(#2A75A9,opacity);
    if(sportsMonth[i] == 8)
      //stroke(108, 203, 178);//purple
      stroke(#7FACCB,opacity);
    if(sportsMonth[i] == 9)
      //stroke(232,152,14);//orange
       stroke(#2A75A9,opacity);
    if(sportsMonth[i] == 10)
      //stroke(210,42,199);//magenta
      stroke(#7FACCB,opacity);
    if(sportsMonth[i] == 11)
      //stroke(186,169,101);//brown
       stroke(#2A75A9,opacity);
    if(sportsMonth[i] == 12)
      //stroke(236,177,185);//pale
      stroke(#7FACCB,opacity);
    //different stroke per month
    strokeWeight(1.5);
    
    //draw lines for sportsitems couts.
    line(width*.02 + i*(.96*width)/(361), height*.9, width*.02 + i*(.96*width)/(361), .8*height - sportsItems[i]);
    
    //beijing olympics
    if( sportsMonth[i] == 8 && sportsDay[i] >= 8 && sportsDay[i] <= 24){
      fill(#FF0000);
      stroke(#FF0000);
      ellipse(width*.02 + i*(.96*width)/(361), height*.91, 1,1);
    }
    fill(#FF0000);
    stroke(#FF0000);
    ellipse(width*.03, height*.45, 7,7);
    textFont(fnt,12);
    textAlign(LEFT);
    fill(#FF0000);
    text("Beijing Olympics" , width*.05, height*.455);
    
    //super bowl
    if( sportsMonth[i] ==2 && sportsDay[i] == 3){
      fill(#006600);
      stroke(#006600);
      ellipse(width*.02 + i*(.96*width)/(361), height*.91, 5,5);
    }
    fill(#006600);
    stroke(#006600);
    ellipse(width*.03, height*.45 + 25, 7,7);
    textFont(fnt,12);
    textAlign(LEFT);
    fill(#006600);
    text("NFL Super Bowl" , width*.05, height*.455 + 25);
    
     //supersonics sold
    if( sportsMonth[i] == 7 && sportsDay[i] == 2){
      fill(#FFFF00);
      stroke(#FFFF00);
      ellipse(width*.02 + i*(.96*width)/(361), height*.91, 5,5);
    }
    fill(#FFFF00);
    stroke(#FFFF00);
    ellipse(width*.03, height*.45 - 25, 7,7);
    textFont(fnt,12);
    textAlign(LEFT);
    fill(#FFFF00);
    text("Seattle Supersonics Leave for Oklahoma" , width*.05, height*.455 - 25);
    
    /*if((sec%12 == 0 || sec%12 == 1 || sec%12 == 2 || sec%12 == 3)){
      strokeWeight(6);
      stroke(60,90,235);//dark blue
      line(width*.05 + maxIndex*(.9*width)/(361), height*.9, width*.05 + maxIndex*(.9*width)/(361), .8*height - sportsItems[maxIndex]);
      //stroke(14,58,232);//dark blue
    }
    else
      stroke(28,0,0); strokeWeight(6);
      line(width*.05 + maxIndex*(.9*width)/(361), height*.9, width*.05 + maxIndex*(.9*width)/(361), .8*height - sportsItems[maxIndex]);
      stroke(14,58,232);strokeWeight(3);
      line(width*.05 + maxIndex*(.9*width)/(361), height*.9, width*.05 + maxIndex*(.9*width)/(361), .8*height - sportsItems[maxIndex]);
     
     if((sec%12 == 8 || sec%12 == 9 || sec%12 == 10 || sec%12 == 11)){
      strokeWeight(5);
      stroke(260,177,185);//dark blue
      line(width*.05 + minIndex*(.9*width)/(361), height*.9, width*.05 + minIndex*(.9*width)/(361), .8*height - sportsItems[minIndex]);
     }
     else
      stroke(28,0,0); strokeWeight(5);
      line(width*.05 + minIndex*(.9*width)/(361), height*.9, width*.05 + minIndex*(.9*width)/(361), .8*height - sportsItems[minIndex]);
      stroke(236,177,185);strokeWeight(3);
      line(width*.05 + minIndex*(.9*width)/(361), height*.9, width*.05 + minIndex*(.9*width)/(361), .8*height - sportsItems[minIndex]);
      */
      stroke(100);
      fill(0);
  }
  sec = second();
  
  //text most popular
      textFont(fnt,22);
      textAlign(LEFT);
      fill(14,58,232);
      text("Most Popular Day, July 2: " + maxS , width*.07, height*.3);
  /*if(!(sec%12 == 0 || sec%12 == 1 || sec%12 == 2 || sec%12 == 3)){
      textFont(fnt,32);
      textAlign(LEFT);
      fill(28,0,0);
      text("Most Popular Day, July 2: " + maxS, width*.05, height*.96);
  }*/
  //avg
  textFont(fnt,22);
  textAlign(CENTER);
  fill(14,58,232);
  text("Average Checkouts Per Day: " + avg, width*.5, height*.3);
      
  //println(sec);
  /*if(!(sec%12 == 4 || sec%12 == 5 || sec%12 == 6 || sec%12 == 7)){
      textFont(fnt,32);
      textAlign(CENTER);
      fill(28,0,0);
      text("Average Checkouts Per Day: " + avg, width*.5, height*.3);
  }*/
  
  //most popular
  textFont(fnt,22);
  textAlign(RIGHT);
  fill(14,58,232);
   text("Least Popular Day, Dec 21: " + minS, width*.93, height*.3);
      
  //println(sec);
  /*if(!(sec%12 == 8 || sec%12 == 9 || sec%12 == 10 || sec%12 == 11)){
      textFont(fnt,32);
      textAlign(RIGHT);
      fill(28,0,0);
      text("Least Popular Day, Dec 21: " + minS, width*.92, height*.96);
  }*/
  
  
  //Month Label
  textFont(fnt,18);
  textAlign(LEFT);
  fill(14,58,232);
  text("Jan"        , width*.02                , height*.94);
  text("Feb"        , width*.02 + (1*width*.96)/12, height*.94);
  text("March"      , width*.02 + (2*width*.96)/12, height*.94);
  text("April"      , width*.02 + (3*width*.96)/12, height*.94);
  text("May"        , width*.02 + (4*width*.96)/12, height*.94);
  text("June"       , width*.02 + (5*width*.96)/12, height*.94);  
  text("July"       , width*.02 + (6*width*.96)/12, height*.94);
  text("Aug"        , width*.02 + (7*width*.97)/12, height*.94);
  text("Sept"       , width*.02 + (8*width*.97)/12, height*.94);
  text("Oct"        , width*.02 + (9*width*.97)/12, height*.94);
  text("Nov"        , width*.02 + (10*width*.97)/12, height*.94);
  text("Dec"        , width*.02 + (11*width*.97)/12, height*.94);
}
  

int findAvg(){
  int total = 0;
  for(int i=0;i<=361;i++){
    total += sportsItems[i];
  }
  return total/362;
}

